import os
import pwd
import logging
import shutil
import commands

class ExportWebSites:
	
	logging.basicConfig(format = '%(asctime)s %(message)s',datefmt = '%m/%d/%Y %I:%M:%S %p',filename = '/var/log/export-web-sites.log',level=logging.DEBUG)
	
	DEBUG=False
	
	moodle="moodle"
	pmb="pmb"
	jclic="jclic"
	dir_export="/etc/apache2/lliurex-location"
	mod_extensions=[".conf",".load"]
	mod_files=["proxy_html","proxy_http"]
	mod_available="/etc/apache2/mods-available/"
	mod_enabled="/etc/apache2/mods-enabled/"
	file_sites_configuration="/etc/apache2/sites-enabled/000-default.conf"
	
	#web_sites=[moodle,jclic,pmb]
	
	
	def create_dict(self,web_sites_vector):
		
		try:
			self.dprint("Creating dictionary for web sites....")
			resume={}
			for sites in web_sites_vector:
				resume[sites]={}
				suffix='.conf'
				site_path=os.path.join(self.dir_export, sites + suffix)
				resume[sites]["file"]=site_path
				resume[sites]["install"]=False
				self.dprint("%s : %s"%(sites,resume[sites]))
			self.dprint("Creating dictionary for web sites: %s"%resume)
			return [True,resume]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,e]
		
	#def create_dict
	
	def lprint(self,arg):
		
		logging.debug(arg)
		
	#def_lprint
	
	def dprint(self,arg):
		
		self.lprint("[ExportWebSitesServer] %s"%arg)
		if ExportWebSites.DEBUG:
			print("[ExportWebSitesServer] %s"%arg)
		
	#def dprint
	
	def export_moodle(self):
		
		try:
			self.dprint("Moodle is exporting....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "moodle" + suffix)
				if not os.path.isfile(site_path):
					os.mknod(site_path)
					os.system('chmod 644 %s'%site_path)
					with open(site_path,'w') as file:
						file.write('<Location /moodle>\n')
						file.write('	SetOutputFilter INFLATE;proxy-html;DEFLATE\n')
						file.write('	ProxyHTMLExtended On\n')
						file.write('	ProxyHTMLURLMap http://moodle/ http://server/moodle/moodle/\n')
						file.write('	ProxyPass http://moodle/\n')
						file.write('	ProxyPassReverse http://moodle/\n')
						file.write('</Location>\n')
						
				self.dprint("Moodle file is created to exported....")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_moodle
	
	def export_jclic(self):
		
		try:
			self.dprint("JCLIC is exporting....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "jclic" + suffix)
				if not os.path.isfile(site_path):
					#os.mknod(site_path)
					pass
				self.dprint("Jclic file is created to exported....")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_jclic
	
	def export_pmb(self):
		
		try:
			self.dprint("PMB is exporting....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "pmb" + suffix)
				if not os.path.isfile(site_path):
					os.mknod(site_path)
					os.system('chmod 644 %s'%site_path)
					with open(site_path,'w') as file:
						file.write('<Location /pmb/>\n')
						file.write('	ProxyPass http://pmb:800/\n')
						file.write('	ProxyPassReverse http://pmb:800/\n')
						file.write('</Location>\n')
				self.dprint("PMB file is created to exported....")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_pmb
	
	def un_export_moodle(self):
		
		try:
			self.dprint("Moodle is cancelling the exportation....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "moodle" + suffix)
				if os.path.isfile(site_path):
					os.remove(site_path)
				self.dprint("Moodle removed !!!")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_moodle
	
	def un_export_jclic(self):
		
		try:
			self.dprint("JCLIC is cancelling the exportation....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "jclic" + suffix)
				if os.path.isfile(site_path):
					os.remove(site_path)
				self.dprint("Jclic removed !!!")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_jclic
	
	def un_export_pmb(self):
		
		try:
			self.dprint("PMB is cancelling the exportation....")
			if self.directory_exist(self.dir_export):
				suffix='.conf'
				site_path=os.path.join(self.dir_export, "pmb" + suffix)
				if os.path.isfile(site_path):
					os.remove(site_path)
				self.dprint("Pmb removed !!!")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def export_pmb
	
	def read_export_sites(self,web_sites):
		
		try:
			self.dprint("READING export sites: %s"%web_sites)
			resume=self.create_dict(web_sites)
			if resume[0]:
				resume=resume[1]
				for service in resume:
					if os.path.exists(resume[service]["file"]):
						resume[service]["install"]=True
				self.dprint(resume)		
				return [True,resume]
			else:
				return [False]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def read_export_sites
	
	
	def directory_exist(self,directory):
		try:
			self.dprint("Testing directory: %s"%directory)
			if not os.path.exists(directory):
				os.makedirs(directory)
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
		
	#def directory_exist
	
	def export_active(self):
		try:
			self.dprint("Activating Exportation.....")
			for filename in self.mod_files:
				for extension in self.mod_extensions:
					if ( filename  == "proxy_http" ):
						extension=".load"
					self.dprint("Creating path file, Path: %s    Filename: %s    Extension: %s"%(self.mod_enabled,filename, extension))
					path_mod_enabled=os.path.join(self.mod_enabled, filename + extension)
					path_mod_available=os.path.join(self.mod_available, filename + extension)
					if not os.path.exists(path_mod_enabled):
						self.dprint("Creating link...")
						os.symlink(path_mod_available,path_mod_enabled)
					else:
						self.dprint("Link exists, do nothing...")
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
	#def export_active
	
	def apache2_restart(self):
		try:
			status, output = commands.getstatusoutput("systemctl restart apache2")
			self.dprint("*** APACHE2 Service ***")
			self.dprint("Status: %s"%status)
			self.dprint("Output: %s"%output)
			return [True,status,output]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
	# def apache2_restart
	
	def sites_configuration(self):
		try:
			modify=True
			path, dirs, files = next(os.walk(self.dir_export))
			number_files=len(files)
			self.dprint("*** Configuration File ***")
			if ( number_files > 0 ):
				self.dprint("Adding configuration line.....")
				if os.path.isfile(self.file_sites_configuration):
					with open(self.file_sites_configuration, "r") as in_file:
						buf = in_file.readlines()
					with open(self.file_sites_configuration, "w") as out_file:
						for line in buf:
							if  "lliurex-location" in line:
								modify=False
							else:
								if ( "<Directory /var/www/admin-center>" in line ) & (modify):
									line = "include /etc/apache2/lliurex-location/*.conf\n" + line
							out_file.write(line)
			else:
				if os.path.isfile(self.file_sites_configuration):
					self.dprint("Deleting configuration line.....")
					self.dprint("Compare this lines:")
					with open(self.file_sites_configuration, "r") as in_file:
						buf = in_file.readlines()
					with open(self.file_sites_configuration, "w") as out_file:
						for line in buf:
							self.dprint(line)
							if "lliurex-location" in line:
								self.dprint("Deleting.......!!!!!!!!!!!!")
								line = "\n"
							out_file.write(line)
				
			return [True]
		
		except Exception as e:
			print ("[ExportWebSitesServer] %s"%e)
			self.dprint(e)
			return [False,str(e)]
	#def sites_configuration